from pystencils import Assignment, fields, Struct, create_kernel, get_code_str


def test_double_pointer():
    f, g = fields(f"f(1),g(1): float64[3D]")

    s1 = Struct("s1", 10)
    s2 = Struct("s2", 10)

    update = Assignment(s2[f.center], s1[g.center])
    ast = create_kernel(update)
    code = get_code_str(ast)
    assert "double **" in code
